-------------------------------- MODULE Test --------------------------------
EXTENDS Integers, TLC

S == 1..2

Max(s) == CHOOSE x \in s : \A y \in s : x >= y


(***
--algorithm PrintSet {
  variable X = S;
  {
e:  print "";
b:    with (x = Max(X)) {
        print x;
        print X;
        X := X \ {x}
      }

  }
}
***)
\* BEGIN TRANSLATION (chksum(pcal) = "e2897145" /\ chksum(tla) = "a33ba03b")
VARIABLES X, pc

vars == << X, pc >>

Init == (* Global variables *)
        /\ X = S
        /\ pc = "e"

e == /\ pc = "e"
     /\ PrintT("")
     /\ pc' = "b"
     /\ X' = X

b == /\ pc = "b"
     /\ LET x == Max(X) IN
          /\ PrintT(x)
          /\ PrintT(X)
          /\ X' = X \ {x}
     /\ pc' = "Done"

(* Allow infinite stuttering to prevent deadlock on termination. *)
Terminating == pc = "Done" /\ UNCHANGED vars

Next == e \/ b
           \/ Terminating

Spec == Init /\ [][Next]_vars

Termination == <>(pc = "Done")

\* END TRANSLATION 

=============================================================================
